#include "skse64/NiRTTI.h"
#include "skse64/NiObjects.h"

NiObject * DoNiRTTICast(NiObject * src, const NiRTTI * typeInfo)
{
	uintptr_t typeAddr = uintptr_t(typeInfo) + RelocationManager::s_baseAddr;
	if (src)
		for (NiRTTI * iter = src->GetRTTI(); iter; iter = iter->parent)
			if (iter == (NiRTTI *)typeAddr)
				return src;

	return nullptr;
}

bool IsType(NiRTTI * rtti, const NiRTTI * typeInfo)
{
	uintptr_t typeAddr = uintptr_t(typeInfo) + RelocationManager::s_baseAddr;
	if (rtti)
		return uintptr_t(rtti) == typeAddr;

	return false;
}

const NiRTTI *	NiRTTI_BGSDecalNode = (NiRTTI *)0x01F5FC20;
const NiRTTI *	NiRTTI_BSAnimGroupSequence = (NiRTTI *)0x01F5FD80;
const NiRTTI *	NiRTTI_BSSplatterExtraData = (NiRTTI *)0x02F60DD0;
const NiRTTI *	NiRTTI_BGSAddonNodeSoundHandleExtra = (NiRTTI *)0x02F61238;
const NiRTTI *	NiRTTI_REFRSyncController = (NiRTTI *)0x02F9B250;
const NiRTTI *	NiRTTI_bhkCartTether = (NiRTTI *)0x02F9C9B8;
const NiRTTI *	NiRTTI_bhkTiltPreventAction = (NiRTTI *)0x02F9C9C8;
const NiRTTI *	NiRTTI_bhkWheelAction = (NiRTTI *)0x02F9C9D8;
const NiRTTI *	NiRTTI_BSFaceGenAnimationData = (NiRTTI *)0x02F9D018;
const NiRTTI *	NiRTTI_BSFaceGenModelExtraData = (NiRTTI *)0x02FA3540;
const NiRTTI *	NiRTTI_BSFaceGenBaseMorphExtraData = (NiRTTI *)0x02FA3568;
const NiRTTI *	NiRTTI_BSFaceGenMorphData = (NiRTTI *)0x02FA3578;
const NiRTTI *	NiRTTI_BSFaceGenMorphDataHead = (NiRTTI *)0x02FA3588;
const NiRTTI *	NiRTTI_BSFaceGenMorphDataHair = (NiRTTI *)0x02FA3598;
const NiRTTI *	NiRTTI_BSFaceGenNiNode = (NiRTTI *)0x02FA35D8;
const NiRTTI *	NiRTTI_BSTempEffect = (NiRTTI *)0x02FA89A8;
const NiRTTI *	NiRTTI_BSTempEffectDebris = (NiRTTI *)0x02FA8A28;
const NiRTTI *	NiRTTI_BSTempEffectGeometryDecal = (NiRTTI *)0x02FA8A48;
const NiRTTI *	NiRTTI_BSTempEffectParticle = (NiRTTI *)0x02FA8AF8;
const NiRTTI *	NiRTTI_BSTempEffectSimpleDecal = (NiRTTI *)0x02FA8B20;
const NiRTTI *	NiRTTI_BSTempEffectSPG = (NiRTTI *)0x02FA8B38;
const NiRTTI *	NiRTTI_bhkAutoWater = (NiRTTI *)0x02FBFF10;
const NiRTTI *	NiRTTI_ModelReferenceEffect = (NiRTTI *)0x02FC1768;
const NiRTTI *	NiRTTI_ReferenceEffect = (NiRTTI *)0x02FC17A0;
const NiRTTI *	NiRTTI_ShaderReferenceEffect = (NiRTTI *)0x02FC17D0;
const NiRTTI *	NiRTTI_SummonPlacementEffect = (NiRTTI *)0x02FC1800;
const NiRTTI *	NiRTTI_SceneGraph = (NiRTTI *)0x02FD4878;
const NiRTTI *	NiRTTI_BSDoorHavokController = (NiRTTI *)0x02FD6598;
const NiRTTI *	NiRTTI_BSPlayerDistanceCheckController = (NiRTTI *)0x02FD65A8;
const NiRTTI *	NiRTTI_BSSimpleScaleController = (NiRTTI *)0x02FD65B8;
const NiRTTI *	NiRTTI_NiObject = (NiRTTI *)0x030AE130;
const NiRTTI *	NiRTTI_NiAVObject = (NiRTTI *)0x030AE168;
const NiRTTI *	NiRTTI_NiNode = (NiRTTI *)0x030AE188;
const NiRTTI *	NiRTTI_NiObjectNET = (NiRTTI *)0x030AE308;
const NiRTTI *	NiRTTI_NiLight = (NiRTTI *)0x030AE360;
const NiRTTI *	NiRTTI_NiSwitchNode = (NiRTTI *)0x030AE370;
const NiRTTI *	NiRTTI_NiStringsExtraData = (NiRTTI *)0x030AE380;
const NiRTTI *	NiRTTI_NiCamera = (NiRTTI *)0x030AE390;
const NiRTTI *	NiRTTI_BSTriShape = (NiRTTI *)0x030AE3A8;
const NiRTTI *	NiRTTI_NiProperty = (NiRTTI *)0x030AE3B8;
const NiRTTI *	NiRTTI_NiAlphaProperty = (NiRTTI *)0x030AE3D0;
const NiRTTI *	NiRTTI_NiSourceTexture = (NiRTTI *)0x030AF408;
const NiRTTI *	NiRTTI_BSFlattenedBoneTree = (NiRTTI *)0x030AF418;
const NiRTTI *	NiRTTI_BSDismemberSkinInstance = (NiRTTI *)0x030AF460;
const NiRTTI *	NiRTTI_NiStringExtraData = (NiRTTI *)0x030AF470;
const NiRTTI *	NiRTTI_NiTimeController = (NiRTTI *)0x030AF480;
const NiRTTI *	NiRTTI_NiExtraData = (NiRTTI *)0x030AF4A0;
const NiRTTI *	NiRTTI_NiGeometryData = (NiRTTI *)0x030AF4B0;
const NiRTTI *	NiRTTI_BSGeometry = (NiRTTI *)0x030AF4C8;
const NiRTTI *	NiRTTI_BSDynamicTriShape = (NiRTTI *)0x030AF4E0;
const NiRTTI *	NiRTTI_NiPointLight = (NiRTTI *)0x030AF4F0;
const NiRTTI *	NiRTTI_NiDefaultAVObjectPalette = (NiRTTI *)0x030AF500;
const NiRTTI *	NiRTTI_NiBillboardNode = (NiRTTI *)0x030AF528;
const NiRTTI *	NiRTTI_NiDirectionalLight = (NiRTTI *)0x030AF538;
const NiRTTI *	NiRTTI_NiCullingProcess = (NiRTTI *)0x030AF548;
const NiRTTI *	NiRTTI_NiParticles = (NiRTTI *)0x030AF560;
const NiRTTI *	NiRTTI_NiTexture = (NiRTTI *)0x030AF5A0;
const NiRTTI *	NiRTTI_NiSkinPartition = (NiRTTI *)0x030AF6B0;
const NiRTTI *	NiRTTI_NiVertWeightsExtraData = (NiRTTI *)0x030AF6C0;
const NiRTTI *	NiRTTI_NiSkinInstance = (NiRTTI *)0x030AF6D0;
const NiRTTI *	NiRTTI_NiAVObjectPalette = (NiRTTI *)0x030AF6E0;
const NiRTTI *	NiRTTI_NiGeometry = (NiRTTI *)0x030AF6F0;
const NiRTTI *	NiRTTI_NiSkinData = (NiRTTI *)0x030AF720;
const NiRTTI *	NiRTTI_NiShadeProperty = (NiRTTI *)0x030AF730;
const NiRTTI *	NiRTTI_NiAlphaAccumulator = (NiRTTI *)0x030AF748;
const NiRTTI *	NiRTTI_NiAmbientLight = (NiRTTI *)0x030AF758;
const NiRTTI *	NiRTTI_NiBinaryExtraData = (NiRTTI *)0x030AF768;
const NiRTTI *	NiRTTI_NiBooleanExtraData = (NiRTTI *)0x030AF778;
const NiRTTI *	NiRTTI_NiBSPNode = (NiRTTI *)0x030AF788;
const NiRTTI *	NiRTTI_NiColorExtraData = (NiRTTI *)0x030AF798;
const NiRTTI *	NiRTTI_NiFloatExtraData = (NiRTTI *)0x030AF7A8;
const NiRTTI *	NiRTTI_NiFloatsExtraData = (NiRTTI *)0x030AF7B8;
const NiRTTI *	NiRTTI_NiFogProperty = (NiRTTI *)0x030AF7C8;
const NiRTTI *	NiRTTI_NiIntegerExtraData = (NiRTTI *)0x030AF7E0;
const NiRTTI *	NiRTTI_NiIntegersExtraData = (NiRTTI *)0x030AF7F0;
const NiRTTI *	NiRTTI_NiParticlesData = (NiRTTI *)0x030AF838;
const NiRTTI *	NiRTTI_NiParticleMeshesData = (NiRTTI *)0x030AF848;
const NiRTTI *	NiRTTI_NiParticleMeshes = (NiRTTI *)0x030AF858;
const NiRTTI *	NiRTTI_NiSpotLight = (NiRTTI *)0x030AF868;
const NiRTTI *	NiRTTI_NiSwitchStringExtraData = (NiRTTI *)0x030AF878;
const NiRTTI *	NiRTTI_NiTriShapeData = (NiRTTI *)0x030AF888;
const NiRTTI *	NiRTTI_NiTriShape = (NiRTTI *)0x030AF898;
const NiRTTI *	NiRTTI_NiTriStripsData = (NiRTTI *)0x030AF8A8;
const NiRTTI *	NiRTTI_NiTriStrips = (NiRTTI *)0x030AF8B8;
const NiRTTI *	NiRTTI_NiVectorExtraData = (NiRTTI *)0x030AF8C8;
const NiRTTI *	NiRTTI_BSLODTriShape = (NiRTTI *)0x030AF8F0;
const NiRTTI *	NiRTTI_NiAdditionalGeometryData = (NiRTTI *)0x030AF900;
const NiRTTI *	NiRTTI_BSSegmentedTriShape = (NiRTTI *)0x030AF918;
const NiRTTI *	NiRTTI_NiBackToFrontAccumulator = (NiRTTI *)0x030AF950;
const NiRTTI *	NiRTTI_NiAccumulator = (NiRTTI *)0x030AF960;
const NiRTTI *	NiRTTI_NiTriBasedGeomData = (NiRTTI *)0x030AF970;
const NiRTTI *	NiRTTI_NiTriBasedGeom = (NiRTTI *)0x030AF980;
const NiRTTI *	NiRTTI_NiCollisionData = (NiRTTI *)0x030AF9C0;
const NiRTTI *	NiRTTI_NiControllerManager = (NiRTTI *)0x030AFA58;
const NiRTTI *	NiRTTI_NiControllerSequence = (NiRTTI *)0x030AFA78;
const NiRTTI *	NiRTTI_NiBlendInterpolator = (NiRTTI *)0x030AFAA8;
const NiRTTI *	NiRTTI_NiMultiTargetTransformController = (NiRTTI *)0x030AFAB8;
const NiRTTI *	NiRTTI_BSMultiTargetTreadTransfController = (NiRTTI *)0x030AFAC8;
const NiRTTI *	NiRTTI_NiInterpController = (NiRTTI *)0x030AFAD8;
const NiRTTI *	NiRTTI_NiFloatData = (NiRTTI *)0x030B08A8;
const NiRTTI *	NiRTTI_NiFloatInterpolator = (NiRTTI *)0x030B08B8;
const NiRTTI *	NiRTTI_NiColorData = (NiRTTI *)0x030B08C8;
const NiRTTI *	NiRTTI_NiColorInterpolator = (NiRTTI *)0x030B08D8;
const NiRTTI *	NiRTTI_NiSingleInterpController = (NiRTTI *)0x030B08E8;
const NiRTTI *	NiRTTI_NiTransformInterpolator = (NiRTTI *)0x030B08F8;
const NiRTTI *	NiRTTI_NiPathInterpolator = (NiRTTI *)0x030B0908;
const NiRTTI *	NiRTTI_NiBlendTransformInterpolator = (NiRTTI *)0x030B0928;
const NiRTTI *	NiRTTI_NiBlendFloatInterpolator = (NiRTTI *)0x030B0938;
const NiRTTI *	NiRTTI_NiFloatExtraDataController = (NiRTTI *)0x030B0948;
const NiRTTI *	NiRTTI_NiTransformController = (NiRTTI *)0x030B0958;
const NiRTTI *	NiRTTI_NiBlendAccumTransformInterpolator = (NiRTTI *)0x030B0968;
const NiRTTI *	NiRTTI_NiInterpolator = (NiRTTI *)0x030B0980;
const NiRTTI *	NiRTTI_BSBlendTreadTransfInterpolator = (NiRTTI *)0x030B09A0;
const NiRTTI *	NiRTTI_NiKeyBasedInterpolator = (NiRTTI *)0x030B09B8;
const NiRTTI *	NiRTTI_NiTransformData = (NiRTTI *)0x030B0A38;
const NiRTTI *	NiRTTI_NiPosData = (NiRTTI *)0x030B0A48;
const NiRTTI *	NiRTTI_NiBlendBoolInterpolator = (NiRTTI *)0x030B0A58;
const NiRTTI *	NiRTTI_NiBlendColorInterpolator = (NiRTTI *)0x030B0A68;
const NiRTTI *	NiRTTI_NiBlendPoint3Interpolator = (NiRTTI *)0x030B0A78;
const NiRTTI *	NiRTTI_NiBlendQuaternionInterpolator = (NiRTTI *)0x030B0A88;
const NiRTTI *	NiRTTI_NiBoolData = (NiRTTI *)0x030B0A98;
const NiRTTI *	NiRTTI_NiBoolInterpolator = (NiRTTI *)0x030B0AA8;
const NiRTTI *	NiRTTI_NiBoolTimelineInterpolator = (NiRTTI *)0x030B0AB8;
const NiRTTI *	NiRTTI_NiBSplineBasisData = (NiRTTI *)0x030B0AC8;
const NiRTTI *	NiRTTI_NiBSplineData = (NiRTTI *)0x030B0AD8;
const NiRTTI *	NiRTTI_NiBSplineColorInterpolator = (NiRTTI *)0x030B0AE8;
const NiRTTI *	NiRTTI_NiBSplineCompColorInterpolator = (NiRTTI *)0x030B0AF8;
const NiRTTI *	NiRTTI_NiBSplineCompFloatInterpolator = (NiRTTI *)0x030B0B08;
const NiRTTI *	NiRTTI_NiBSplineCompPoint3Interpolator = (NiRTTI *)0x030B0B18;
const NiRTTI *	NiRTTI_NiBSplineCompTransformInterpolator = (NiRTTI *)0x030B0B28;
const NiRTTI *	NiRTTI_NiBSplineFloatInterpolator = (NiRTTI *)0x030B0B38;
const NiRTTI *	NiRTTI_NiBSplinePoint3Interpolator = (NiRTTI *)0x030B0B48;
const NiRTTI *	NiRTTI_NiBSplineTransformInterpolator = (NiRTTI *)0x030B0B58;
const NiRTTI *	NiRTTI_NiColorExtraDataController = (NiRTTI *)0x030B0B68;
const NiRTTI *	NiRTTI_NiFloatsExtraDataController = (NiRTTI *)0x030B0B78;
const NiRTTI *	NiRTTI_NiFloatsExtraDataPoint3Controller = (NiRTTI *)0x030B0B88;
const NiRTTI *	NiRTTI_NiKeyframeManager = (NiRTTI *)0x030B0BA0;
const NiRTTI *	NiRTTI_NiLightColorController = (NiRTTI *)0x030B0BB0;
const NiRTTI *	NiRTTI_NiLightDimmerController = (NiRTTI *)0x030B0BC0;
const NiRTTI *	NiRTTI_NiLookAtController = (NiRTTI *)0x030B0BD0;
const NiRTTI *	NiRTTI_NiLookAtInterpolator = (NiRTTI *)0x030B0BE0;
const NiRTTI *	NiRTTI_NiMorphData = (NiRTTI *)0x030B0BF0;
const NiRTTI *	NiRTTI_NiPathController = (NiRTTI *)0x030B0C00;
const NiRTTI *	NiRTTI_NiPoint3Interpolator = (NiRTTI *)0x030B0C10;
const NiRTTI *	NiRTTI_NiQuaternionInterpolator = (NiRTTI *)0x030B0C20;
const NiRTTI *	NiRTTI_NiRollController = (NiRTTI *)0x030B0C30;
const NiRTTI *	NiRTTI_NiRotData = (NiRTTI *)0x030B0C40;
const NiRTTI *	NiRTTI_NiSequence = (NiRTTI *)0x030B0C50;
const NiRTTI *	NiRTTI_NiSequenceStreamHelper = (NiRTTI *)0x030B0C70;
const NiRTTI *	NiRTTI_NiStringPalette = (NiRTTI *)0x030B0C80;
const NiRTTI *	NiRTTI_NiTextKeyExtraData = (NiRTTI *)0x030B0C90;
const NiRTTI *	NiRTTI_NiUVData = (NiRTTI *)0x030B0CA0;
const NiRTTI *	NiRTTI_NiVisController = (NiRTTI *)0x030B0CB0;
const NiRTTI *	NiRTTI_BSAnimNote = (NiRTTI *)0x030B0CC0;
const NiRTTI *	NiRTTI_BSAnimNotes = (NiRTTI *)0x030B0CD0;
const NiRTTI *	NiRTTI_BSGrabIKNote = (NiRTTI *)0x030B0CE0;
const NiRTTI *	NiRTTI_BSLookIKNote = (NiRTTI *)0x030B0CF0;
const NiRTTI *	NiRTTI_BSRotAccumTransfInterpolator = (NiRTTI *)0x030B0D00;
const NiRTTI *	NiRTTI_BSTreadTransfInterpolator = (NiRTTI *)0x030B0D10;
const NiRTTI *	NiRTTI_BSFrustumFOVController = (NiRTTI *)0x030B0D20;
const NiRTTI *	NiRTTI_NiExtraDataController = (NiRTTI *)0x030B0DB8;
const NiRTTI *	NiRTTI_NiBSplineInterpolator = (NiRTTI *)0x030B0DC8;
const NiRTTI *	NiRTTI_NiPoint3InterpController = (NiRTTI *)0x030B0DD8;
const NiRTTI *	NiRTTI_NiFloatInterpController = (NiRTTI *)0x030B0DE8;
const NiRTTI *	NiRTTI_NiFloatController = (NiRTTI *)0x030B0DF8;
const NiRTTI *	NiRTTI_NiBoolInterpController = (NiRTTI *)0x030B0E08;
const NiRTTI *	NiRTTI_NiParticleSystem = (NiRTTI *)0x030B0E20;
const NiRTTI *	NiRTTI_NiPSysEmitterCtlr = (NiRTTI *)0x030B0E30;
const NiRTTI *	NiRTTI_NiPSysGravityModifier = (NiRTTI *)0x030B0E40;
const NiRTTI *	NiRTTI_BSPSysHavokUpdateModifier = (NiRTTI *)0x030B0E50;
const NiRTTI *	NiRTTI_NiMeshParticleSystem = (NiRTTI *)0x030B0E68;
const NiRTTI *	NiRTTI_NiPSysCylinderEmitter = (NiRTTI *)0x030B0E80;
const NiRTTI *	NiRTTI_BSStripParticleSystem = (NiRTTI *)0x030B0E90;
const NiRTTI *	NiRTTI_NiPSysEmitter = (NiRTTI *)0x030B0EA0;
const NiRTTI *	NiRTTI_NiPSysModifierCtlr = (NiRTTI *)0x030B0EB0;
const NiRTTI *	NiRTTI_NiPSysModifier = (NiRTTI *)0x030B0EC8;
const NiRTTI *	NiRTTI_NiPSysMeshUpdateModifier = (NiRTTI *)0x030B0ED8;
const NiRTTI *	NiRTTI_NiPSysUpdateCtlr = (NiRTTI *)0x030B0EE8;
const NiRTTI *	NiRTTI_NiMeshPSysData = (NiRTTI *)0x030B0EF8;
const NiRTTI *	NiRTTI_NiPSysAirFieldAirFrictionCtlr = (NiRTTI *)0x030B0F08;
const NiRTTI *	NiRTTI_NiPSysAirFieldInheritVelocityCtlr = (NiRTTI *)0x030B0F18;
const NiRTTI *	NiRTTI_NiPSysAirFieldModifier = (NiRTTI *)0x030B0F28;
const NiRTTI *	NiRTTI_NiPSysAirFieldSpreadCtlr = (NiRTTI *)0x030B0F38;
const NiRTTI *	NiRTTI_NiPSysAgeDeathModifier = (NiRTTI *)0x030B0F48;
const NiRTTI *	NiRTTI_NiPSysBombModifier = (NiRTTI *)0x030B0F58;
const NiRTTI *	NiRTTI_NiPSysBoundUpdateModifier = (NiRTTI *)0x030B0F68;
const NiRTTI *	NiRTTI_NiPSysBoxEmitter = (NiRTTI *)0x030B0F78;
const NiRTTI *	NiRTTI_NiPSysColliderManager = (NiRTTI *)0x030B0F88;
const NiRTTI *	NiRTTI_NiPSysColorModifier = (NiRTTI *)0x030B0F98;
const NiRTTI *	NiRTTI_NiPSysData = (NiRTTI *)0x030B0FA8;
const NiRTTI *	NiRTTI_NiPSysDragFieldModifier = (NiRTTI *)0x030B0FB8;
const NiRTTI *	NiRTTI_NiPSysDragModifier = (NiRTTI *)0x030B0FC8;
const NiRTTI *	NiRTTI_NiPSysEmitterCtlrData = (NiRTTI *)0x030B0FD8;
const NiRTTI *	NiRTTI_NiPSysEmitterDeclinationCtlr = (NiRTTI *)0x030B0FE8;
const NiRTTI *	NiRTTI_NiPSysEmitterDeclinationVarCtlr = (NiRTTI *)0x030B0FF8;
const NiRTTI *	NiRTTI_NiPSysEmitterInitialRadiusCtlr = (NiRTTI *)0x030B1008;
const NiRTTI *	NiRTTI_NiPSysEmitterLifeSpanCtlr = (NiRTTI *)0x030B1018;
const NiRTTI *	NiRTTI_NiPSysEmitterPlanarAngleCtlr = (NiRTTI *)0x030B1028;
const NiRTTI *	NiRTTI_NiPSysEmitterPlanarAngleVarCtlr = (NiRTTI *)0x030B1038;
const NiRTTI *	NiRTTI_NiPSysEmitterSpeedCtlr = (NiRTTI *)0x030B1048;
const NiRTTI *	NiRTTI_NiPSysFieldAttenuationCtlr = (NiRTTI *)0x030B1058;
const NiRTTI *	NiRTTI_NiPSysFieldMagnitudeCtlr = (NiRTTI *)0x030B1068;
const NiRTTI *	NiRTTI_NiPSysFieldMaxDistanceCtlr = (NiRTTI *)0x030B1078;
const NiRTTI *	NiRTTI_NiPSysGravityFieldModifier = (NiRTTI *)0x030B1088;
const NiRTTI *	NiRTTI_NiPSysGravityStrengthCtlr = (NiRTTI *)0x030B1098;
const NiRTTI *	NiRTTI_NiPSysGrowFadeModifier = (NiRTTI *)0x030B10A8;
const NiRTTI *	NiRTTI_NiPSysInitialRotAngleCtlr = (NiRTTI *)0x030B10B8;
const NiRTTI *	NiRTTI_NiPSysInitialRotAngleVarCtlr = (NiRTTI *)0x030B10C8;
const NiRTTI *	NiRTTI_NiPSysInitialRotSpeedCtlr = (NiRTTI *)0x030B10D8;
const NiRTTI *	NiRTTI_NiPSysInitialRotSpeedVarCtlr = (NiRTTI *)0x030B10E8;
const NiRTTI *	NiRTTI_NiPSysMeshEmitter = (NiRTTI *)0x030B10F8;
const NiRTTI *	NiRTTI_NiPSysModifierActiveCtlr = (NiRTTI *)0x030B1128;
const NiRTTI *	NiRTTI_NiPSysPlanarCollider = (NiRTTI *)0x030B1138;
const NiRTTI *	NiRTTI_NiPSysPositionModifier = (NiRTTI *)0x030B1148;
const NiRTTI *	NiRTTI_NiPSysRadialFieldModifier = (NiRTTI *)0x030B1158;
const NiRTTI *	NiRTTI_NiPSysResetOnLoopCtlr = (NiRTTI *)0x030B1168;
const NiRTTI *	NiRTTI_NiPSysRotationModifier = (NiRTTI *)0x030B1178;
const NiRTTI *	NiRTTI_NiPSysSpawnModifier = (NiRTTI *)0x030B1188;
const NiRTTI *	NiRTTI_NiPSysSphereEmitter = (NiRTTI *)0x030B1198;
const NiRTTI *	NiRTTI_NiPSysSphericalCollider = (NiRTTI *)0x030B11A8;
const NiRTTI *	NiRTTI_NiPSysTurbulenceFieldModifier = (NiRTTI *)0x030B11B8;
const NiRTTI *	NiRTTI_NiPSysVortexFieldModifier = (NiRTTI *)0x030B11C8;
const NiRTTI *	NiRTTI_BSStripPSysData = (NiRTTI *)0x030B11D8;
const NiRTTI *	NiRTTI_BSPSysRecycleBoundModifier = (NiRTTI *)0x030B11F0;
const NiRTTI *	NiRTTI_BSPSysInheritVelocityModifier = (NiRTTI *)0x030B1200;
const NiRTTI *	NiRTTI_NiPSysVolumeEmitter = (NiRTTI *)0x030B1210;
const NiRTTI *	NiRTTI_NiPSysModifierFloatCtlr = (NiRTTI *)0x030B1220;
const NiRTTI *	NiRTTI_NiPSysFieldModifier = (NiRTTI *)0x030B1230;
const NiRTTI *	NiRTTI_NiPSysModifierBoolCtlr = (NiRTTI *)0x030B1240;
const NiRTTI *	NiRTTI_NiPSysCollider = (NiRTTI *)0x030B1250;
const NiRTTI *	NiRTTI_BSMultiBound = (NiRTTI *)0x030B9508;
const NiRTTI *	NiRTTI_BSMultiBoundRoom = (NiRTTI *)0x030B9518;
const NiRTTI *	NiRTTI_BSMultiBoundAABB = (NiRTTI *)0x030B9530;
const NiRTTI *	NiRTTI_BSMultiBoundOBB = (NiRTTI *)0x030B9548;
const NiRTTI *	NiRTTI_BSXFlags = (NiRTTI *)0x030B9568;
const NiRTTI *	NiRTTI_BSValueNode = (NiRTTI *)0x030B9580;
const NiRTTI *	NiRTTI_BSWindModifier = (NiRTTI *)0x030BFB00;
const NiRTTI *	NiRTTI_BSTempNodeManager = (NiRTTI *)0x030BFB20;
const NiRTTI *	NiRTTI_BSTempNode = (NiRTTI *)0x030BFB30;
const NiRTTI *	NiRTTI_BSOcclusionShape = (NiRTTI *)0x030BFB50;
const NiRTTI *	NiRTTI_BSRangeNode = (NiRTTI *)0x030BFC48;
const NiRTTI *	NiRTTI_BSBlastNode = (NiRTTI *)0x030BFE80;
const NiRTTI *	NiRTTI_BSDebrisNode = (NiRTTI *)0x030BFE90;
const NiRTTI *	NiRTTI_BSDamageStage = (NiRTTI *)0x030BFEA0;
const NiRTTI *	NiRTTI_BSPSysArrayEmitter = (NiRTTI *)0x030BFEB0;
const NiRTTI *	NiRTTI_PArrayPoint = (NiRTTI *)0x030BFEC0;
const NiRTTI *	NiRTTI_BSMultiStreamInstanceTriShape = (NiRTTI *)0x030BFEE8;
const NiRTTI *	NiRTTI_BSMultiBoundShape = (NiRTTI *)0x030BFF18;
const NiRTTI *	NiRTTI_BSMultiBoundSphere = (NiRTTI *)0x030BFF28;
const NiRTTI *	NiRTTI_BSOcclusionBox = (NiRTTI *)0x030BFF40;
const NiRTTI *	NiRTTI_BSOcclusionPlane = (NiRTTI *)0x030BFF58;
const NiRTTI *	NiRTTI_BSPortal = (NiRTTI *)0x030BFF68;
const NiRTTI *	NiRTTI_BSPortalSharedNode = (NiRTTI *)0x030BFF78;
const NiRTTI *	NiRTTI_BSBodyMorphOffsetsExtraData = (NiRTTI *)0x030BFF90;
const NiRTTI *	NiRTTI_BSBehaviorGraphExtraData = (NiRTTI *)0x030BFFA0;
const NiRTTI *	NiRTTI_NiBSBoneLODController = (NiRTTI *)0x030BFFB8;
const NiRTTI *	NiRTTI_BSCullingProcess = (NiRTTI *)0x030BFFD8;
const NiRTTI *	NiRTTI_BSParticleSystemManager = (NiRTTI *)0x030BFFF8;
const NiRTTI *	NiRTTI_BSFurnitureMarkerNode = (NiRTTI *)0x030C0020;
const NiRTTI *	NiRTTI_BSBound = (NiRTTI *)0x030C00A0;
const NiRTTI *	NiRTTI_BSMultiBoundNode = (NiRTTI *)0x030C00C0;
const NiRTTI *	NiRTTI_BSBoneMap = (NiRTTI *)0x030C00D0;
const NiRTTI *	NiRTTI_BSAnimInteractionMarker = (NiRTTI *)0x030C00E8;
const NiRTTI *	NiRTTI_BSSceneGraph = (NiRTTI *)0x030C0100;
const NiRTTI *	NiRTTI_BSPSysMultiTargetEmitterCtlr = (NiRTTI *)0x030C0118;
const NiRTTI *	NiRTTI_BSGeometryListCullingProcess = (NiRTTI *)0x030C0130;
const NiRTTI *	NiRTTI_BSSubIndexTriShape = (NiRTTI *)0x030C0148;
const NiRTTI *	NiRTTI_BSDistantObjectLargeRefExtraData = (NiRTTI *)0x030C0158;
const NiRTTI *	NiRTTI_BSMasterParticleSystem = (NiRTTI *)0x030C1B20;
const NiRTTI *	NiRTTI_BSProceduralLightningController = (NiRTTI *)0x030C1B48;
const NiRTTI *	NiRTTI_BSInvMarker = (NiRTTI *)0x030C1B58;
const NiRTTI *	NiRTTI_BSBoneLODExtraData = (NiRTTI *)0x030C1B70;
const NiRTTI *	NiRTTI_BSReference = (NiRTTI *)0x030C1B90;
const NiRTTI *	NiRTTI_BSNodeReferences = (NiRTTI *)0x030C1BA0;
const NiRTTI *	NiRTTI_BSDecalPlacementVectorExtraData = (NiRTTI *)0x030C1BB0;
const NiRTTI *	NiRTTI_BSParentVelocityModifier = (NiRTTI *)0x030C1BC0;
const NiRTTI *	NiRTTI_BSWArray = (NiRTTI *)0x030C1BD0;
const NiRTTI *	NiRTTI_BSMultiBoundCapsule = (NiRTTI *)0x030C1BE8;
const NiRTTI *	NiRTTI_BSPSysStripUpdateModifier = (NiRTTI *)0x030C1BF8;
const NiRTTI *	NiRTTI_BSPSysSubTexModifier = (NiRTTI *)0x030C1C08;
const NiRTTI *	NiRTTI_BSPSysScaleModifier = (NiRTTI *)0x030C1C18;
const NiRTTI *	NiRTTI_BSLagBoneController = (NiRTTI *)0x030C1C28;
const NiRTTI *	NiRTTI_BSNonUniformScaleExtraData = (NiRTTI *)0x030C1C38;
const NiRTTI *	NiRTTI_BSNiNode = (NiRTTI *)0x030C1C50;
const NiRTTI *	NiRTTI_BSInstanceTriShape = (NiRTTI *)0x030C1C60;
const NiRTTI *	NiRTTI_bhkWorldObject = (NiRTTI *)0x030C8158;
const NiRTTI *	NiRTTI_bhkWorld = (NiRTTI *)0x030C8198;
const NiRTTI *	NiRTTI_bhkRigidBody = (NiRTTI *)0x030C92D8;
const NiRTTI *	NiRTTI_bhkCollisionObject = (NiRTTI *)0x030C92F0;
const NiRTTI *	NiRTTI_bhkNiCollisionObject = (NiRTTI *)0x030C93A0;
const NiRTTI *	NiRTTI_bhkAttachmentCollisionObject = (NiRTTI *)0x030C9420;
const NiRTTI *	NiRTTI_WeaponObject = (NiRTTI *)0x030C9430;
const NiRTTI *	NiRTTI_bhkRigidBodyT = (NiRTTI *)0x030C9458;
const NiRTTI *	NiRTTI_bhkWorldM = (NiRTTI *)0x030C9468;
const NiRTTI *	NiRTTI_bhkRefObject = (NiRTTI *)0x030C9490;
const NiRTTI *	NiRTTI_bhkSerializable = (NiRTTI *)0x030C94A0;
const NiRTTI *	NiRTTI_bhkShape = (NiRTTI *)0x030C94D0;
const NiRTTI *	NiRTTI_bhkEntity = (NiRTTI *)0x030C94E8;
const NiRTTI *	NiRTTI_bhkPhantom = (NiRTTI *)0x030C9500;
const NiRTTI *	NiRTTI_bhkAabbPhantom = (NiRTTI *)0x030C9518;
const NiRTTI *	NiRTTI_bhkSphereRepShape = (NiRTTI *)0x030C9530;
const NiRTTI *	NiRTTI_bhkConvexShape = (NiRTTI *)0x030C9548;
const NiRTTI *	NiRTTI_bhkPCollisionObject = (NiRTTI *)0x030C9558;
const NiRTTI *	NiRTTI_hkPackedNiTriStripsData = (NiRTTI *)0x030C9568;
const NiRTTI *	NiRTTI_bhkShapePhantom = (NiRTTI *)0x030C9580;
const NiRTTI *	NiRTTI_bhkSimpleShapePhantom = (NiRTTI *)0x030C9598;
const NiRTTI *	NiRTTI_bhkCapsuleShape = (NiRTTI *)0x030C95B0;
const NiRTTI *	NiRTTI_bhkBoxShape = (NiRTTI *)0x030C95C8;
const NiRTTI *	NiRTTI_bhkSphereShape = (NiRTTI *)0x030C95E0;
const NiRTTI *	NiRTTI_bhkBvTreeShape = (NiRTTI *)0x030C95F8;
const NiRTTI *	NiRTTI_bhkNiTriStripsShape = (NiRTTI *)0x030C9610;
const NiRTTI *	NiRTTI_bhkPackedNiTriStripsShape = (NiRTTI *)0x030C9638;
const NiRTTI *	NiRTTI_bhkBlendCollisionObject = (NiRTTI *)0x030C9650;
const NiRTTI *	NiRTTI_bhkAvoidBox = (NiRTTI *)0x030C9670;
const NiRTTI *	NiRTTI_bhkLimitedHingeConstraint = (NiRTTI *)0x030C9688;
const NiRTTI *	NiRTTI_bhkMalleableConstraint = (NiRTTI *)0x030C96A0;
const NiRTTI *	NiRTTI_bhkUnaryAction = (NiRTTI *)0x030C96B8;
const NiRTTI *	NiRTTI_bhkConstraint = (NiRTTI *)0x030C96D0;
const NiRTTI *	NiRTTI_bhkPrismaticConstraint = (NiRTTI *)0x030C96E8;
const NiRTTI *	NiRTTI_bhkAction = (NiRTTI *)0x030C9700;
const NiRTTI *	NiRTTI_bhkTriSampledHeightFieldBvTreeShape = (NiRTTI *)0x030C9718;
const NiRTTI *	NiRTTI_bhkCachingShapePhantom = (NiRTTI *)0x030CA388;
const NiRTTI *	NiRTTI_bhkRagdollTemplateData = (NiRTTI *)0x030CA3B0;
const NiRTTI *	NiRTTI_bhkRagdollTemplate = (NiRTTI *)0x030CA3C0;
const NiRTTI *	NiRTTI_bhkSPCollisionObject = (NiRTTI *)0x030CA3D0;
const NiRTTI *	NiRTTI_bhkMouseSpringAction = (NiRTTI *)0x030CA3E8;
const NiRTTI *	NiRTTI_bhkHingeConstraint = (NiRTTI *)0x030CA400;
const NiRTTI *	NiRTTI_bhkCompressedMeshShape = (NiRTTI *)0x030CA478;
const NiRTTI *	NiRTTI_bhkCompressedMeshShapeData = (NiRTTI *)0x030CA488;
const NiRTTI *	NiRTTI_bhkConvexSweepShape = (NiRTTI *)0x030CA4A0;
const NiRTTI *	NiRTTI_bhkConvexTransformShape = (NiRTTI *)0x030CA4B8;
const NiRTTI *	NiRTTI_bhkConvexTranslateShape = (NiRTTI *)0x030CA4D0;
const NiRTTI *	NiRTTI_bhkConvexVerticesShape = (NiRTTI *)0x030CA4E8;
const NiRTTI *	NiRTTI_bhkCylinderShape = (NiRTTI *)0x030CA500;
const NiRTTI *	NiRTTI_bhkMultiSphereShape = (NiRTTI *)0x030CA518;
const NiRTTI *	NiRTTI_bhkPlaneShape = (NiRTTI *)0x030CA530;
const NiRTTI *	NiRTTI_bhkTriangleShape = (NiRTTI *)0x030CA548;
const NiRTTI *	NiRTTI_bhkMoppBvTreeShape = (NiRTTI *)0x030CA560;
const NiRTTI *	NiRTTI_bhkTransformShape = (NiRTTI *)0x030CA578;
const NiRTTI *	NiRTTI_bhkListShape = (NiRTTI *)0x030CA590;
const NiRTTI *	NiRTTI_bhkBallAndSocketConstraint = (NiRTTI *)0x030CA5A8;
const NiRTTI *	NiRTTI_bhkBallSocketConstraintChain = (NiRTTI *)0x030CA5C0;
const NiRTTI *	NiRTTI_bhkGroupConstraint = (NiRTTI *)0x030CA5D8;
const NiRTTI *	NiRTTI_bhkHingeLimitsConstraint = (NiRTTI *)0x030CA5F0;
const NiRTTI *	NiRTTI_bhkFixedConstraint = (NiRTTI *)0x030CA608;
const NiRTTI *	NiRTTI_bhkRagdollConstraint = (NiRTTI *)0x030CA620;
const NiRTTI *	NiRTTI_bhkRagdollLimitsConstraint = (NiRTTI *)0x030CA638;
const NiRTTI *	NiRTTI_bhkStiffSpringConstraint = (NiRTTI *)0x030CA650;
const NiRTTI *	NiRTTI_bhkWheelConstraint = (NiRTTI *)0x030CA668;
const NiRTTI *	NiRTTI_bhkBreakableConstraint = (NiRTTI *)0x030CA680;
const NiRTTI *	NiRTTI_bhkAngularDashpotAction = (NiRTTI *)0x030CA698;
const NiRTTI *	NiRTTI_bhkDashpotAction = (NiRTTI *)0x030CA6B0;
const NiRTTI *	NiRTTI_bhkLiquidAction = (NiRTTI *)0x030CA6C8;
const NiRTTI *	NiRTTI_bhkMotorAction = (NiRTTI *)0x030CA6E8;
const NiRTTI *	NiRTTI_bhkOrientHingedBodyAction = (NiRTTI *)0x030CA700;
const NiRTTI *	NiRTTI_bhkSpringAction = (NiRTTI *)0x030CA718;
const NiRTTI *	NiRTTI_bhkBlendController = (NiRTTI *)0x030CA728;
const NiRTTI *	NiRTTI_bhkExtraData = (NiRTTI *)0x030CA738;
const NiRTTI *	NiRTTI_bhkPoseArray = (NiRTTI *)0x030CA748;
const NiRTTI *	NiRTTI_bhkGenericConstraint = (NiRTTI *)0x030CA768;
const NiRTTI *	NiRTTI_bhkCharControllerShape = (NiRTTI *)0x030CA778;
const NiRTTI *	NiRTTI_bhkCollisionBox = (NiRTTI *)0x030CA790;
const NiRTTI *	NiRTTI_bhkShapeCollection = (NiRTTI *)0x030CA7A8;
const NiRTTI *	NiRTTI_bhkPositionConstraintMotor = (NiRTTI *)0x030CA810;
const NiRTTI *	NiRTTI_bhkVelocityConstraintMotor = (NiRTTI *)0x030CA820;
const NiRTTI *	NiRTTI_bhkSpringDamperConstraintMotor = (NiRTTI *)0x030CA830;
const NiRTTI *	NiRTTI_bhkCharacterProxy = (NiRTTI *)0x030CB5E8;
const NiRTTI *	NiRTTI_bhkCharacterRigidBody = (NiRTTI *)0x030CB600;
const NiRTTI *	NiRTTI_bhkHeightFieldShape = (NiRTTI *)0x030CC908;
const NiRTTI *	NiRTTI_bhkConstraintChain = (NiRTTI *)0x030CC920;
const NiRTTI *	NiRTTI_bhkBinaryAction = (NiRTTI *)0x030CC938;
const NiRTTI *	NiRTTI_bhkPointToPathConstraint = (NiRTTI *)0x030CC970;
const NiRTTI *	NiRTTI_DebugTextExtraData = (NiRTTI *)0x030CE170;
const NiRTTI *	NiRTTI_BSFadeNode = (NiRTTI *)0x0326C0E8;
const NiRTTI *	NiRTTI_BSShaderProperty = (NiRTTI *)0x0326C118;
const NiRTTI *	NiRTTI_BSLeafAnimNode = (NiRTTI *)0x0326C128;
const NiRTTI *	NiRTTI_BSTreeNode = (NiRTTI *)0x0326C138;
const NiRTTI *	NiRTTI_ShadowSceneNode = (NiRTTI *)0x0326C560;
const NiRTTI *	NiRTTI_BSLightingShaderProperty = (NiRTTI *)0x0326CE30;
const NiRTTI *	NiRTTI_BSGrassShaderProperty = (NiRTTI *)0x0326CE68;
const NiRTTI *	NiRTTI_BSShaderAccumulator = (NiRTTI *)0x0326D080;
const NiRTTI *	NiRTTI_BSEffectShaderProperty = (NiRTTI *)0x0326D220;
const NiRTTI *	NiRTTI_BSWaterShaderProperty = (NiRTTI *)0x032CE048;
const NiRTTI *	NiRTTI_BSBloodSplatterShaderProperty = (NiRTTI *)0x032CE058;
const NiRTTI *	NiRTTI_BSParticleShaderProperty = (NiRTTI *)0x032CE448;
const NiRTTI *	NiRTTI_BSTextureSet = (NiRTTI *)0x032CE798;
const NiRTTI *	NiRTTI_BSShaderTextureSet = (NiRTTI *)0x032CE7A8;
const NiRTTI *	NiRTTI_BSSkyShaderProperty = (NiRTTI *)0x032CEAA8;
const NiRTTI *	NiRTTI_BSFadeNodeCuller = (NiRTTI *)0x0331EB30;
const NiRTTI *	NiRTTI_BSDistantTreeShaderProperty = (NiRTTI *)0x0331EB60;
const NiRTTI *	NiRTTI_BSCubeMapCamera = (NiRTTI *)0x0331ED40;
const NiRTTI *	NiRTTI_BSFogProperty = (NiRTTI *)0x0331EDF8;
const NiRTTI *	NiRTTI_BSClearZNode = (NiRTTI *)0x03530EB8;
const NiRTTI *	NiRTTI_NiCollisionObject = (NiRTTI *)0x03530FD8;
const NiRTTI *	NiRTTI_BSOrderedNode = (NiRTTI *)0x03530FE8;
const NiRTTI *	NiRTTI_BSLines = (NiRTTI *)0x03530FF8;
const NiRTTI *	NiRTTI_BSDynamicLines = (NiRTTI *)0x03531008;
const NiRTTI *	NiRTTI_BSMultiIndexTriShape = (NiRTTI *)0x03531028;
const NiRTTI *	NiRTTI_BSLightingShaderPropertyFloatController = (NiRTTI *)0x035310D0;
const NiRTTI *	NiRTTI_BSLightingShaderPropertyUShortController = (NiRTTI *)0x035310E8;
const NiRTTI *	NiRTTI_BSLightingShaderPropertyColorController = (NiRTTI *)0x03531100;
const NiRTTI *	NiRTTI_BSEffectShaderPropertyFloatController = (NiRTTI *)0x03531138;
const NiRTTI *	NiRTTI_BSEffectShaderPropertyColorController = (NiRTTI *)0x03531150;
const NiRTTI *	NiRTTI_BSNiAlphaPropertyTestRefController = (NiRTTI *)0x03531160;
const NiRTTI *	NiRTTI_BSPSysSimpleColorModifier = (NiRTTI *)0x03531170;
const NiRTTI *	NiRTTI_BSPSysLODModifier = (NiRTTI *)0x03531180;
const NiRTTI *	NiRTTI_BSParabolicCullingProcess = (NiRTTI *)0x03531608;
const NiRTTI *	NiRTTI_BSMeshLODTriShape = (NiRTTI *)0x03531618;
const NiRTTI *	NiRTTI_BSLODMultiIndexTriShape = (NiRTTI *)0x03531628;
const NiRTTI *	NiRTTI_BSSubIndexLandTriShape = (NiRTTI *)0x03531640;
